Description

On IRC someone asked how to find out if a directory is empty or not, from within ruby.

It seems as if there was no simple way.

I suggest adding Dir.empty?

On IRC, someone else suggested this:

Dir.entries(dir).size == 2

 I do not know if there are better ways but possibly that could

be used for a Dir.empty? functionality?

Related issues:

Related to Ruby - Feature #12010: Exclude dot and dotdot from Dir#each Closed

Associated revisions

Revision 135a171ce11dc56d037bfc9c5c50b006042621c4 - 02/16/2016 08:34 AM - nobu (Nobuyoshi Nakada)

dir.c: Dir.empty?

dir.c (rb_dir_s_empty_p): add Dir.empty? method, which tells the

argument is the name of an empty directory.  [Feature #10121]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@53841 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 135a171c - 02/16/2016 08:34 AM - nobu (Nobuyoshi Nakada)

dir.c: Dir.empty?

dir.c (rb_dir_s_empty_p): add Dir.empty? method, which tells the

argument is the name of an empty directory.  [Feature #10121]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@53841 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 09/10/2014 02:28 AM - nobu (Nobuyoshi Nakada)

- Description updated

- Category set to core

- Status changed from Open to Feedback

What should happen if the dir is not a directory name?

Just returns false, or raises Errno::ENOTDIR?

#2 - 09/10/2014 06:18 AM - nobu (Nobuyoshi Nakada)

https://github.com/nobu/ruby/compare/Feature%2310121-Dir.empty-p

#3 - 01/21/2016 03:46 AM - nobu (Nobuyoshi Nakada)

- Related to Feature #12010: Exclude dot and dotdot from Dir#each added

#4 - 01/21/2016 03:50 AM - nobu (Nobuyoshi Nakada)

- Assignee set to matz (Yukihiro Matsumoto)
https://github.com/nobu/ruby/compare/Feature%2310121-Dir.empty-p


On Windows, root directories of drives don't contain "." nor "..",

and the suggested code (also Dir.entries(dirname).join == "...") doesn't work.

If it is needed in real case, this method should be adopted, I think.

#5 - 02/16/2016 08:34 AM - nobu (Nobuyoshi Nakada)

- Status changed from Feedback to Closed

Applied in changeset r53841.

dir.c: Dir.empty?

dir.c (rb_dir_s_empty_p): add Dir.empty? method, which tells the

argument is the name of an empty directory.  [Feature #10121]

#6 - 02/16/2016 05:05 PM - shevegen (Robert A. Heiler)

Woot! Woot!

Thanks to nobu the patch monster and matz!

#7 - 02/17/2016 01:58 PM - lucasbuchala (Lucas Buchala)

Now that Ruby got a Dir.empty? method, do you think it makes sense to add a File.empty? as an alias for File.zero? ?

(I didn't know if it was worth opening a new issue for this simple suggestion, so I just appended it here, since I see Dir.empty? and File.empty? as

related methods, somehow)

#8 - 07/18/2016 04:01 AM - backus (John Backus)

I commented this on #9969 as well. Given that Dir.empty? is being introduced I think it would be helpful to also introduce either Pathname#empty?

(which would check if something is a file or a directory then do the respective empty check) or Pathname#empty_directory? (which would assume the

path is referring to a directory).
